unit Unit1;

interface

uses Windows, SysUtils, Classes, Controls, Forms, Dialogs, registry, StdCtrls, ComCtrls, shlobj;

const
  key = 'SOFTWARE\FileSplitter\Options';

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    CheckBox1: TCheckBox;
    ProgressBar1: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
  public
  end;

var
  Form1:TForm1;
  IniReg:TregIniFile;
  InitDirSplit,InitDirOpen:string;
  defolt:string;

implementation

{$R *.dfm}

function BrowseCallbackProc(DialogHWND: THandle;NINT: Integer; PARAM1: lParam; PARAM2: lParam): integer; stdcall;
begin
 if NInt = BFFM_INITIALIZED then SendMessage(DialogHWND,BFFM_SETSELECTION,1,integer(PChar(defolt)));
 result:=0;
end;

function DirDialog:string;
var
 TitleName:string;
 lpItemID:PItemIDList;
 BrowseInfo:TBrowseInfo;
 DisplayName:array[0..MAX_PATH] of char;
 TempPath:array[0..MAX_PATH] of char;
begin
 FillChar(BrowseInfo, sizeof(TBrowseInfo),#0);
 BrowseInfo.hwndOwner:=Form1.Handle;
 BrowseInfo.lpfn:=@BrowseCallbackProc;
 BrowseInfo.pszDisplayName:=@DisplayName;
 TitleName:='    ';
 BrowseInfo.lpszTitle:=PChar(TitleName);
 BrowseInfo.ulFlags:=BIF_RETURNONLYFSDIRS;
 lpItemID:=SHBrowseForFolder(BrowseInfo);
 if lpItemId <> nil then begin
  SHGetPathFromIDList(lpItemID, TempPath);
  result:=TempPath;
  GlobalFreePtr(lpItemID);
 end else result:='';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  ReadBuf:array of byte;
  InFile,Outfile:cardinal;
  ReadBufSize,BytesRead,ReadCur,i,
  BytesWritten,LastDelta,C,PartLen:cardinal;
  ReadTotal,FileS:int64;
  max,k:word;
  str,path:string;
  HW,LW:cardinal;
begin
 opendialog1.Filter:='';
 opendialog1.Title:='   ';
 opendialog1.InitialDir:=InitDirOpen;
 if opendialog1.Execute then begin
  InFile:=CreateFile(Pchar(OpenDialog1.FileName),
          GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  LW:=GetFileSize(inFile,@HW);
  FileS:=LW+HW*4294967296;
  str:=edit1.Text;
  i:=Pos('.',str);
  if i<>0 then begin
   str[i]:=',';
   edit1.Text:=str;
  end; 

  PartLen:=round(1048576*strtofloat(edit1.Text))-4;//4 -     
  if FileS<=PartLen then begin
   MessageBox(form1.Handle,'    ', '',MB_OK+MB_ICONERROR);
   exit;
  end;

  defolt:=extractfilepath(OpenDialog1.FileName);  //  
  path:=DirDialog; //  
  if path<>'' then begin

   if partLen<1048572 then ReadBufSize:=partLen else ReadBufSize:=1048572;//        1 
   setlength(ReadBuf,ReadBufSize);

   i:=PartLen div ReadBufSize;
   Max:=FileS div PartLen;

   LastDelta:=PartLen-i*ReadBufSize;
   if LastDelta<>0 then inc(i);
   c:=FileS-Max*PartLen;

   ProgressBar1.max:=i*max+(c div ReadBufSize);

   if c<>0 then inc(max);
   ProgressBar1.Visible:=true;
   button1.Enabled:=false;
   button2.Enabled:=false;
   try
    SetFilePointer(InFile,0,nil,FILE_BEGIN);
    ReadTotal:=0;
    for c:=1 to max do begin
     Outfile:=CreateFile(Pchar(path+'/'+extractfilename(OpenDialog1.FileName)+'.part'+inttostr(c)),
             GENERIC_READ+GENERIC_WRITE,FILE_SHARE_READ,nil,CREATE_ALWAYS,0,0);
     if Outfile=INVALID_HANDLE_VALUE then begin
      MessageBox(form1.Handle,'  ', '',mb_ok+MB_ICONERROR);
      closehandle(Outfile);
      button1.Enabled:=true;
      button2.Enabled:=true;
      Exit;
     end;
     WriteFile(Outfile,'',2,BytesWritten,nil); // 
     WriteFile(Outfile,max,2,BytesWritten,nil); //    - 
     ReadCur:=0;
     if partLen<1048572 then ReadBufSize:=partLen else ReadBufSize:=1048572;
     repeat begin
      ReadFile(InFile,ReadBuf[0],ReadBufSize,BytesRead,nil);
      WriteFile(Outfile,ReadBuf[0],BytesRead,BytesWritten,nil);
      ReadTotal:=ReadTotal+BytesRead;
      ReadCur:=ReadCur+BytesRead;
      if (ReadCur+ReadBufSize)>=PartLen then ReadBufSize:=PartLen-ReadCur;//   
      if (ReadTotal+LastDelta)=FileS then ReadBufSize:=LastDelta;  //   
      ProgressBar1.stepit;
      application.ProcessMessages;
     end until (ReadCur=PartLen)or(ReadTotal=FileS);
     SetEndOfFile(Outfile);
     closehandle(Outfile);
    end;
   finally
    closehandle(InFile);
    ProgressBar1.Visible:=false;
    application.ProcessMessages;
    ProgressBar1.max:=0;
    ProgressBar1.StepIt;
    button1.Enabled:=true;
    button2.Enabled:=true;
   end;
   c:=max;
   max:=c-(c div 10)*10;
   k:=c-(c div 100)*100;
   if (max=1)and(k<>11) then str:=' ' else
   if (max>4) or ((k>9) and (k<20)) then str:=' ' else str:=' ';
   MessageBox(form1.Handle,pchar(' "'+extractfilename(OpenDialog1.FileName)+'"   '+inttostr(c)+str),'!',mb_ok+MB_ICONINFORMATION);
   InitDirOpen:=extractfilepath(opendialog1.FileName);
  end; 
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  ReadBuf:array of byte;
  InFile,Outfile:cardinal;
  ReadBufSize,BytesRead,BytesWritten,C,max,z,LastDelta:cardinal;
  ReadTotal,FileS,FF,FL:int64;
  HW,LW:cardinal;
  str,res,path:string;
begin
 FF:=0;
 FL:=0;
 opendialog1.Filter:='*.part*|*.part*';
 opendialog1.Title:='    ';
 opendialog1.InitialDir:=InitDirSplit;
 if opendialog1.Execute then begin
  str:=OpenDialog1.FileName;
  c:=length(str)-5;
  repeat
   if (lowercase(str[c])='.') and
    (lowercase(str[c+1])='p') and
    (lowercase(str[c+2])='a') and
    (lowercase(str[c+3])='r') and
    (lowercase(str[c+4])='t') then begin
     break;
    end;
    dec(c);
  until c=1;

  if c=1 then begin
   MessageBox(form1.Handle,pchar(' "'+extractfilename(str)+'" - '), '',mb_ok+MB_ICONERROR);
   exit;
  end;
  dec(c);
  str:=copy(str,0,c);

  InFile:=CreateFile(Pchar(OpenDialog1.FileName),GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  SetFilePointer(InFile,0,nil,FILE_BEGIN);
  ReadFile(InFile,max,2,BytesRead,nil);  //   
  if max<>60138{''} then begin
   MessageBox(form1.Handle,pchar(' "'+extractfilename(OpenDialog1.FileName)+'" - '), '',mb_ok+MB_ICONERROR);
   closehandle(InFile);
   exit;
  end;
  ReadFile(InFile,max,2,BytesRead,nil); //     
  if max<=0 then begin
   MessageBox(form1.Handle,pchar(' "'+extractfilename(OpenDialog1.FileName)+'" - '), '',mb_ok+MB_ICONERROR);
   closehandle(InFile);
   exit;
  end;
  closehandle(InFile);

  for c:=1 to max do begin  //  
   res:=str+'.part'+inttostr(c);
   if FileExists(res)=false then begin
    MessageBox(form1.Handle,pchar('   '+inttostr(c)), '',mb_ok);
    exit;
   end;
   InFile:=CreateFile(Pchar(res),GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);

   if c=1 then begin  //  
    LW:=GetFileSize(InFile,@HW);
    FF:=(LW+HW*4294967296)-4;
   end;

   if c=max then begin  //   ( ProgressBar1)
    LW:=GetFileSize(InFile,@HW);
    FL:=(LW+HW*4294967296)-4;
   end;

   SetFilePointer(InFile,0,nil,FILE_BEGIN);
   ReadFile(InFile,z,2,BytesRead,nil);
   if z<>60138{''} then begin
    MessageBox(form1.Handle,pchar(' "'+extractfilename(res)+'" - '), '',mb_ok+MB_ICONERROR);
    closehandle(InFile);
    exit;
   end;
   ReadFile(InFile,z,2,BytesRead,nil);
   if z<>max then begin
    MessageBox(form1.Handle,pchar(' "'+extractfilename(res)+'" - '), '',mb_ok+MB_ICONERROR);
    closehandle(InFile);
    exit;
   end;
   closehandle(InFile);
  end;
  //    -  

  defolt:=extractfilepath(OpenDialog1.FileName);  //  
  path:=DirDialog; //  
  if path<>'' then begin
   path:=path+'/'+extractfilename(str);

   if FileExists(path) then if
    messagebox(form1.Handle,'      .'+
    #13#10+#13#10+'  ?','',MB_YESNO or MB_ICONQUESTION)=idNO then exit;

   Outfile:=CreateFile(Pchar(path),GENERIC_READ+GENERIC_WRITE,FILE_SHARE_READ,nil,CREATE_ALWAYS,0,0);
   if Outfile=INVALID_HANDLE_VALUE then begin
    MessageBox(form1.Handle,'  ', '',mb_ok);
    closehandle(Outfile);
    Exit;
   end;

   if FF<1048576 then C:=FF else C:=1048576;
   FileS:=FF div c;
   if (FF-(c*FileS))<>0 then FF:=FileS+1 else FF:=FileS;

   if FL<1048576 then C:=FL else C:=1048576;
   FileS:=FL div c;
   if (FL-(c*FileS))<>0 then FL:=FileS+1 else FL:=FileS;

   ProgressBar1.max:=FF*(max-1)+FL;
   ProgressBar1.Visible:=true;
   button1.Enabled:=false;
   button2.Enabled:=false;
   for c:=1 to max do begin
    res:=str+'.part'+inttostr(c);
    InFile:=CreateFile(Pchar(res),
            GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
    LW:=GetFileSize(inFile,@HW);
    FileS:=(LW+HW*4294967296)-4;

    if FileS<1048576 then ReadBufSize:=FileS else ReadBufSize:=1048576;
    setlength(ReadBuf,ReadBufSize);

    SetFilePointer(InFile,4,nil,FILE_BEGIN);
    LastDelta:=FileS-(FileS div ReadBufSize)*ReadBufSize;
    ReadTotal:=0;
    repeat begin
     ReadFile(InFile,ReadBuf[0],ReadBufSize,BytesRead,nil);
     WriteFile(Outfile,ReadBuf[0],BytesRead,BytesWritten,nil);
     ReadTotal:=ReadTotal+BytesRead;
     if (ReadTotal+LastDelta)=FileS then ReadBufSize:=LastDelta;  //  
     ProgressBar1.stepit; 
     application.ProcessMessages;
    end until ReadTotal=FileS;

    closehandle(InFile);
   end;
   SetEndOfFile(Outfile);
   if closehandle(Outfile) then
   if checkbox1.Checked then for c:=1 to max do DeleteFile(str+'.part'+inttostr(c));

   ProgressBar1.Visible:=false;
   application.ProcessMessages;
   ProgressBar1.max:=0;
   ProgressBar1.StepIt;
   button1.Enabled:=true;
   button2.Enabled:=true;
   MessageBox(form1.Handle,pchar(' "'+extractfilename(str)+'" !'),'!',mb_ok+MB_ICONINFORMATION);
   InitDirSplit:=extractfilepath(opendialog1.FileName);
  end; 
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 INIReg:=TregIniFile.Create;
 Form1.Top:=INIReg.ReadInteger(key,'FormTop',-110+GetSystemMetrics(SM_CYSCREEN)div 2);
 Form1.Left:=INIReg.ReadInteger(key,'FormLeft',-110+GetSystemMetrics(SM_CXSCREEN)div 2);
 edit1.Text:=INIReg.ReadString(key,'Size','3');
 checkbox1.Checked:=INIReg.ReadBool(key,'Del',true);
 InitDirSplit:=INIReg.ReadString(key,'DirSplit','');
 InitDirOpen:=INIReg.ReadString(key,'DirOpen','');
 INIReg.CloseKey;
 INIReg.Free;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 INIReg:=TregIniFile.Create;
 INIReg.WriteInteger(key,'FormTop',Form1.Top);
 INIReg.WriteInteger(key,'FormLeft',Form1.Left);
 INIReg.WriteString(key,'Size',edit1.Text);
 INIReg.WriteBool(key,'Del',checkbox1.Checked);
 INIReg.WriteString(key,'DirSplit',InitDirSplit);
 INIReg.WriteString(key,'DirOpen',InitDirOpen);
 INIReg.CloseKey;
 INIReg.Free;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if ((byte(key)<48)and(byte(key)<>8)and(byte(key)<>44)and(byte(key)<>46)) or (byte(key)>57) then key:=#0;
 if (byte(key)=44) and (pos(',',tedit(sender).Text)>0) then key:=#0;
 if (byte(key)=46) and (pos('.',tedit(sender).Text)>0) then key:=#0; 
end;

end.
